string currentChatMessage = "";

void readLastChatMessage() {
    if (Permissions::InGameChat()) {
        while(true) {
            if (getNetwork() !is null) {
                MwFastBuffer<wstring> chatHistory = getNetwork().ChatHistoryLines;
                if (chatHistory.Length > 0) {
                    string chatMessage = chatHistory[0];
                    if (chatMessage != currentChatMessage && !hasVoteTimeout) {
                        currentChatMessage = chatMessage;
                        if (checkIfMessageIsByCurrentClient()) {
                            sendRequestIfMessageMatchForVoting();
                        }
                    }
                }
                yield();
            }
        }
    }
}

bool checkIfMessageIsByCurrentClient() {
    string user = currentChatMessage.SubStr(3,currentChatMessage.IndexOf('$>]')-3);
    if (user == getName()) {
        return true;
    }
    return false;
}

void sendRequestIfMessageMatchForVoting() {
    string message = currentChatMessage.SubStr(currentChatMessage.IndexOf('$>] ')+4);
    if (message == '+++') newSelectedVoteByChat(3, 100);
    if (message == '++') newSelectedVoteByChat(2, 80);
    if (message == '+') newSelectedVoteByChat(1, 60);
    if (message == '-') newSelectedVoteByChat(4, 40);
    if (message == '--') newSelectedVoteByChat(5, 20);
    if (message == '---') newSelectedVoteByChat(6, 0);
}

void printVote(int vote) {
    if (Setting_Chat_Show_Voting) {
        CGamePlaygroundInterface@ playgroundInterface = getPlaygroundInterface();
        playgroundInterface.ChatEntry = getVoteText(vote);
    }
}

string getVoteText(int vote) {
    string startText = "";
    switch(vote) {
        case 0: startText = "$F00   "; break;
        case 20: startText = "$F00  "; break;
        case 40: startText = "$F00 "; break;
        case 60: startText = "$0F0 "; break;
        case 80: startText = "$0F0  "; break;
        case 100: startText = "$0F0   "; break;
    }
    return startText;
}